/* dclibc.h -- definizioni principali */
/******************************************************************************
* DCLibC - Direct Connect C library                                           *
*                                                                             *
* Copyright (C) 2005-2007 daniele_athome                                      *
*                                                                             *
* This program is free software; you can redistribute it and/or               *
* modify it under the terms of the GNU General Public License                 *
* as published by the Free Software Foundation; either version 2              *
* of the License, or (at your option) any later version.                      *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program; if not, write to the Free Software                 *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*******************************************************************************/

#ifndef DCLIBC_H
#define DCLIBC_H

#include <glib.h>
#include <dclibc/hub.h>
#include <dclibc/hubconn.h>
#include <dclibc/dcproto.h>
#include <dclibc/userinfo.h>
#include <dclibc/userlist.h>
#include <dclibc/search.h>

G_BEGIN_DECLS

#define DCLIBC_MAJOR_VERSION	0
#define DCLIBC_MINOR_VERSION	1
#define DCLIBC_MICRO_VERSION	1
#define DCLIBC_EXTRA_VERSION	"-debug1"

extern      const guint dclibc_major_version;
extern      const guint dclibc_minor_version;
extern      const guint dclibc_micro_version;
const gchar* dclibc_check_version(guint required_major,guint required_minor,guint required_micro);

#define DCLIBC_CHECK_VERSION(major,minor,micro)    \
    (DCLIBC_MAJOR_VERSION > (major) || \
     (DCLIBC_MAJOR_VERSION == (major) && DCLIBC_MINOR_VERSION > (minor)) || \
     (DCLIBC_MAJOR_VERSION == (major) && DCLIBC_MINOR_VERSION == (minor) && \
      DCLIBC_MICRO_VERSION >= (micro)))

typedef void (*MainLoopFunc)(void);

gboolean dclibc_init(MainLoopFunc loop_func,MainLoopFunc loop_exit);
gboolean dclibc_main(void);
gboolean dclibc_main_quit(void);

gpointer dclibc_trash_add(gpointer data);
gboolean dclibc_trash_flush(void);

#define DCTRASH(__x)		dclibc_trash_add(__x)
#define DCFLUSH()		dclibc_trash_flush()

G_END_DECLS

#endif	/* DCLIBC_H */
