/* userlist.h -- lista utenti */
/******************************************************************************
* DCLibC - Direct Connect C library                                           *
*                                                                             *
* Copyright (C) 2005-2007 daniele_athome                                      *
*                                                                             *
* This program is free software; you can redistribute it and/or               *
* modify it under the terms of the GNU General Public License                 *
* as published by the Free Software Foundation; either version 2              *
* of the License, or (at your option) any later version.                      *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program; if not, write to the Free Software                 *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*******************************************************************************/

#ifndef DCLIBC_USERLIST_H
#define DCLIBC_USERLIST_H

#include <glib.h>
#include <dclibc/userinfo.h>

G_BEGIN_DECLS

/* array di userinfo_t */
typedef GPtrArray userlist_t;

userlist_t * userlist_new(void);
void userlist_delete(userlist_t * list);
gboolean userlist_add(userlist_t * list,userinfo_t * user);
gboolean userlist_remove(userlist_t * list,const char * nick);
void userlist_clear(userlist_t * list);
void userlist_update(userlist_t * list,userinfo_t * user);

const userinfo_t * userlist_get_from_nick(userlist_t * list,const char * nick);

#define userlist_get_size(x)	(((userlist_t *)x)->len)
#define userlist_get_index(x,n)	(userinfo_t *)(((userlist_t *)x)->pdata[n])

G_END_DECLS

#endif	/* DCLIBC_USERLIST_H */
